﻿<Graph ClassName="SalesForecastLine" Source="#CDATA" IsNew="True" FileType="NewDac">
    <CDATA name="Source"><![CDATA[using System;
using PX.Data;
using PX.Objects.IN;

namespace SF
{
  [Serializable]
  public class SalesForecastLine : IBqlTable
  {
    #region RefNbr
    [PXDBString(15, IsUnicode = true, InputMask = "", IsKey = true)]
        [PXDBDefault(typeof(SalesForecast.refNbr))]
    [PXUIField(DisplayName = "Ref Nbr")]
    public virtual string RefNbr { get; set; }
    public abstract class refNbr : PX.Data.BQL.BqlString.Field<refNbr> { }
    #endregion

    #region InventoryID
        [StockItem(IsKey = true)]
    [PXUIField(DisplayName = "Inventory ID")]
    public virtual int? InventoryID { get; set; }
    public abstract class inventoryID : PX.Data.BQL.BqlInt.Field<inventoryID> { }
        #endregion

        #region Uom
        [INUnit(typeof(inventoryID), DisplayName = "UOM")]
        [PXDefault(typeof(Search<InventoryItem.salesUnit, Where<InventoryItem.inventoryID, Equal<Current<inventoryID>>>>))]
        [PXUIField(DisplayName = "UOM")]
    public virtual string Uom { get; set; }
    public abstract class uom : PX.Data.BQL.BqlString.Field<uom> { }
    #endregion

    #region Qty
    [PXDBQuantity()]
        [PXDefault(TypeCode.Decimal, "0.0")]
        [PXUIField(DisplayName = "Qty")]
    public virtual Decimal? Qty { get; set; }
    public abstract class qty : PX.Data.BQL.BqlDecimal.Field<qty> { }
        #endregion

        #region ProdLedger
        [PXDBQuantity()]
        [PXDefault(TypeCode.Decimal, "0.0")]
        [PXUIField(DisplayName = "Prod On Hand Qty", Enabled = false)]
    public virtual Decimal? ProdLedger { get; set; }
    public abstract class prodLedger : PX.Data.BQL.BqlDecimal.Field<prodLedger> { }
        #endregion

        #region ItemBalances
        [PXDBQuantity()]
        [PXDefault(TypeCode.Decimal, "0.0")]
        [PXUIField(DisplayName = "Unserved Deliveries", Enabled = false)]
    public virtual Decimal? ItemBalances { get; set; }
    public abstract class itemBalances : PX.Data.BQL.BqlDecimal.Field<itemBalances> { }
        #endregion

        #region ForDelivery
        [PXDBQuantity()]
        [PXDefault(TypeCode.Decimal, "0.0")]
        [PXUIField(DisplayName = "Delivery Balance (Current Month)", Enabled = false)]
    public virtual Decimal? ForDelivery { get; set; }
    public abstract class forDelivery : PX.Data.BQL.BqlDecimal.Field<forDelivery> { }
        #endregion

        #region Remaining
        [PXDBQuantity()]
        [PXDefault(TypeCode.Decimal, "0.0")]
        [PXFormula(typeof(Sub<prodLedger, Add<itemBalances, forDelivery>>), null)]
        [PXUIField(DisplayName = "Prod Available Qty", Enabled = false)]
    public virtual Decimal? Remaining { get; set; }
    public abstract class remaining : PX.Data.BQL.BqlDecimal.Field<remaining> { }
        #endregion

        #region Jan
        [PXDBQuantity()]
        [PXDefault(TypeCode.Decimal, "0.0")]
        [PXUIField(DisplayName = "Jan", Enabled = false)]
    public virtual Decimal? Jan { get; set; }
    public abstract class jan : PX.Data.BQL.BqlDecimal.Field<jan> { }
        #endregion
        
        #region Feb
        [PXDBQuantity()]
        [PXDefault(TypeCode.Decimal, "0.0")]
        [PXUIField(DisplayName = "Feb", Enabled = false)]
    public virtual Decimal? Feb { get; set; }
    public abstract class feb : PX.Data.BQL.BqlDecimal.Field<feb> { }
        #endregion

        #region Mar
        [PXDBQuantity()]
        [PXDefault(TypeCode.Decimal, "0.0")]
        [PXUIField(DisplayName = "Mar", Enabled = false)]
    public virtual Decimal? Mar { get; set; }
    public abstract class mar : PX.Data.BQL.BqlDecimal.Field<mar> { }
        #endregion

        #region Apr
        [PXDBQuantity()]
        [PXDefault(TypeCode.Decimal, "0.0")]
        [PXUIField(DisplayName = "Apr", Enabled = false)]
    public virtual Decimal? Apr { get; set; }
    public abstract class apr : PX.Data.BQL.BqlDecimal.Field<apr> { }
        #endregion

        #region May
        [PXDBQuantity()]
        [PXDefault(TypeCode.Decimal, "0.0")]
        [PXUIField(DisplayName = "May", Enabled = false)]
    public virtual Decimal? May { get; set; }
    public abstract class may : PX.Data.BQL.BqlDecimal.Field<may> { }
        #endregion

        #region Jun
        [PXDBQuantity()]
        [PXDefault(TypeCode.Decimal, "0.0")]
        [PXUIField(DisplayName = "Jun", Enabled = false)]
    public virtual Decimal? Jun { get; set; }
    public abstract class jun : PX.Data.BQL.BqlDecimal.Field<jun> { }
        #endregion

        #region Jul
        [PXDBQuantity()]
        [PXDefault(TypeCode.Decimal, "0.0")]
        [PXUIField(DisplayName = "Jul", Enabled = false)]
    public virtual Decimal? Jul { get; set; }
    public abstract class jul : PX.Data.BQL.BqlDecimal.Field<jul> { }
        #endregion

        #region Aug
        [PXDBQuantity()]
        [PXDefault(TypeCode.Decimal, "0.0")]
        [PXUIField(DisplayName = "Aug", Enabled = false)]
    public virtual Decimal? Aug { get; set; }
    public abstract class aug : PX.Data.BQL.BqlDecimal.Field<aug> { }
        #endregion

        #region Sep
        [PXDBQuantity()]
        [PXDefault(TypeCode.Decimal, "0.0")]
        [PXUIField(DisplayName = "Sep", Enabled = false)]
    public virtual Decimal? Sep { get; set; }
    public abstract class sep : PX.Data.BQL.BqlDecimal.Field<sep> { }
        #endregion

        #region Oct
        [PXDBQuantity()]
        [PXDefault(TypeCode.Decimal, "0.0")]
        [PXUIField(DisplayName = "Oct", Enabled = false)]
    public virtual Decimal? Oct { get; set; }
    public abstract class oct : PX.Data.BQL.BqlDecimal.Field<oct> { }
        #endregion

        #region Nov
        [PXDBQuantity()]
        [PXDefault(TypeCode.Decimal, "0.0")]
        [PXUIField(DisplayName = "Nov", Enabled = false)]
    public virtual Decimal? Nov { get; set; }
    public abstract class nov : PX.Data.BQL.BqlDecimal.Field<nov> { }
        #endregion

        #region Dec
        [PXDBQuantity()]
        [PXDefault(TypeCode.Decimal, "0.0")]
        [PXUIField(DisplayName = "Dec", Enabled = false)]
    public virtual Decimal? Dec { get; set; }
    public abstract class dec : PX.Data.BQL.BqlDecimal.Field<dec> { }
        #endregion

        #region TotalProd
        [PXDBQuantity()]
        [PXDefault(TypeCode.Decimal, "0.0")]
        [PXFormula(typeof(Sub<remaining, Add<jan, Add<feb, Add<mar, Add<apr, Add<may,
            Add<jun, Add<jul, Add<aug, Add<sep, Add<oct, Add<nov, dec>>>>>>>>>>>>), null)]
        [PXUIField(DisplayName = "Total for Production (in UOM)", Enabled = false)]
    public virtual Decimal? TotalProd { get; set; }
    public abstract class totalProd : PX.Data.BQL.BqlDecimal.Field<totalProd> { }
        #endregion

        #region UnitPrice
        [PXDBPriceCost()]
        [PXDefault(TypeCode.Decimal, "0.0")]
        [PXUIField(DisplayName = "Unit Price")]
        public virtual Decimal? UnitPrice { get; set; }
        public abstract class unitPrice : PX.Data.BQL.BqlDecimal.Field<unitPrice> { }
        #endregion

        #region TotalPrice
        [PXDBPriceCost()]
        [PXDefault(TypeCode.Decimal, "0.0")]
        [PXFormula(typeof(Mult<totalProd, unitPrice>), null)]
        [PXUIField(DisplayName = "Total Price", Enabled = false)]
        public virtual Decimal? TotalPrice { get; set; }
        public abstract class totalPrice : PX.Data.BQL.BqlDecimal.Field<totalPrice> { }
        #endregion

        #region TotalBaseUnit
        [PXDBQuantity()]
        [PXDefault(TypeCode.Decimal, "0.0")]
        [PXFormula(typeof(Mult<qty, totalProd>), null)]
        [PXUIField(DisplayName = "Total for Production (in base unit)", Enabled = false)]
    public virtual Decimal? TotalBaseUnit { get; set; }
    public abstract class totalBaseUnit : PX.Data.BQL.BqlDecimal.Field<totalBaseUnit> { }
        #endregion
        

    #region CreatedByID
    [PXDBCreatedByID()]
    public virtual Guid? CreatedByID { get; set; }
    public abstract class createdByID : PX.Data.BQL.BqlGuid.Field<createdByID> { }
    #endregion

    #region CreatedByScreenID
    [PXDBCreatedByScreenID()]
    public virtual string CreatedByScreenID { get; set; }
    public abstract class createdByScreenID : PX.Data.BQL.BqlString.Field<createdByScreenID> { }
    #endregion

    #region CreatedDateTime
    [PXDBCreatedDateTime()]
    [PXUIField(DisplayName = "Created Date Time")]
    public virtual DateTime? CreatedDateTime { get; set; }
    public abstract class createdDateTime : PX.Data.BQL.BqlDateTime.Field<createdDateTime> { }
    #endregion

    #region LastModifiedByID
    [PXDBLastModifiedByID()]
    public virtual Guid? LastModifiedByID { get; set; }
    public abstract class lastModifiedByID : PX.Data.BQL.BqlGuid.Field<lastModifiedByID> { }
    #endregion

    #region LastModifiedByScreenID
    [PXDBLastModifiedByScreenID()]
    public virtual string LastModifiedByScreenID { get; set; }
    public abstract class lastModifiedByScreenID : PX.Data.BQL.BqlString.Field<lastModifiedByScreenID> { }
    #endregion

    #region LastModifiedDateTime
    [PXDBLastModifiedDateTime()]
    [PXUIField(DisplayName = "Last Modified Date Time")]
    public virtual DateTime? LastModifiedDateTime { get; set; }
    public abstract class lastModifiedDateTime : PX.Data.BQL.BqlDateTime.Field<lastModifiedDateTime> { }
    #endregion

    #region Tstamp
    [PXDBTimestamp()]
    [PXUIField(DisplayName = "Tstamp")]
    public virtual byte[] Tstamp { get; set; }
    public abstract class tstamp : PX.Data.BQL.BqlByteArray.Field<tstamp> { }
    #endregion

    #region RecordID
    [PXDBIdentity()]
    [PXUIField(DisplayName = "Record ID")]
    public virtual int? RecordID { get; set; }
    public abstract class recordID : PX.Data.BQL.BqlInt.Field<recordID> { }
    #endregion
  }
}]]></CDATA>
</Graph>